nextest:build:x86_64:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-musl
  tags: ["_docker", "x86_64"]
  needs: []
  interruptible: true
  variables:
    RUSTFLAGS: -C opt-level=z -C strip=symbols -C panic=abort -C lto=true -C embed-bitcode=yes -C codegen-units=1
  artifacts:
    paths: [nextest/target/x86_64-unknown-linux-musl/release/cargo-nextest]
  script:
    - export NEXTEST_VERSION="$(./parse_nextest_version.sh)"
    - git clone --branch="cargo-nextest-${NEXTEST_VERSION}" "https://github.com/nextest-rs/nextest.git" "nextest"
    - cargo zigbuild --manifest-path="nextest/Cargo.toml" --target="x86_64-unknown-linux-musl" --release

nextest:build:aarch64:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-aarch64-unknown-linux-musl
  tags: ["_docker", "x86_64"]
  needs: []
  interruptible: true
  variables:
    RUSTFLAGS: -C opt-level=z -C strip=symbols -C panic=abort -C lto=true -C embed-bitcode=yes -C codegen-units=1
  artifacts:
    paths: [nextest/target/aarch64-unknown-linux-musl/release/cargo-nextest]
  script:
    - export NEXTEST_VERSION="$(./parse_nextest_version.sh)"
    - git clone --branch="cargo-nextest-${NEXTEST_VERSION}" "https://github.com/nextest-rs/nextest.git" "nextest"
    - cargo zigbuild --manifest-path="nextest/Cargo.toml" --target="aarch64-unknown-linux-musl" --release

image:build:x86_64:
  image: registry.gitlab.com/sbenv/veroxis/images/kaniko:1.22.0
  needs: ["nextest:build:x86_64"]
  tags: ["_docker", "x86_64"]
  interruptible: true
  artifacts:
    expire_in: 1 days
    paths: ["image.x86_64.tar"]
  script:
    - mv "nextest/target/x86_64-unknown-linux-musl/release/cargo-nextest" "cargo-nextest-bin"
    - >
      executor
      --image-fs-extract-retry=42
      --push-retry=42
      --context="${CI_PROJECT_DIR}"
      --dockerfile="${CI_PROJECT_DIR}/Dockerfile"
      --destination="${CI_REGISTRY_IMAGE:latest}"
      --snapshotMode=redo
      --no-push
      --tarPath="image.x86_64.tar"

image:build:aarch64:
  image: registry.gitlab.com/sbenv/veroxis/images/kaniko:1.22.0
  needs: ["nextest:build:aarch64"]
  tags: ["_docker", "aarch64"]
  interruptible: true
  artifacts:
    expire_in: 1 days
    paths: ["image.aarch64.tar"]
  script:
    - mv "nextest/target/aarch64-unknown-linux-musl/release/cargo-nextest" "cargo-nextest-bin"
    - >
      executor
      --image-fs-extract-retry=42
      --push-retry=42
      --context="${CI_PROJECT_DIR}"
      --dockerfile="${CI_PROJECT_DIR}/Dockerfile"
      --destination="${CI_REGISTRY_IMAGE:latest}"
      --snapshotMode=redo
      --no-push
      --tarPath="image.aarch64.tar"

image:publish:release:
  image: registry.gitlab.com/sbenv/veroxis/images/podman:4.9.4
  interruptible: true
  only: ["master"]
  needs:
    - image:build:x86_64
    - image:build:aarch64
  script:
    - podman login -u "${CI_REGISTRY_USER}" -p "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"
    - podman manifest create "${CI_REGISTRY_IMAGE}:latest"
    - podman manifest add "${CI_REGISTRY_IMAGE}:latest" docker-archive:./image.x86_64.tar
    - podman manifest add "${CI_REGISTRY_IMAGE}:latest" docker-archive:./image.aarch64.tar
    - podman manifest push --all --format="v2s2" "${CI_REGISTRY_IMAGE}:latest" "docker://${CI_REGISTRY_IMAGE}:latest"
    - podman manifest push --all --format="v2s2" "${CI_REGISTRY_IMAGE}:latest" "docker://${CI_REGISTRY_IMAGE}:$(./parse_nextest_version.sh)"
